#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define SWAP(x,y) {double t=(x); (x)=(y); (y)=t;}
static double eps=1.0e-12; /* 要調整 */

int lu(int n,double **a,int*p){ int i,j,k,l;
  for(i=0;i<n;i++) p[i]=i;
  for(k=0;k<n;k++){ double pv=0;
    for(l=k,i=k;i<n;i++)
      if(fabs(a[i][k])>pv){pv=fabs(a[i][k]);l=i;}
    if(pv<eps) return -1;
    if(l!=k){int tmp=p[l]; p[l]=p[k]; p[k]=tmp;
             for(j=0;j<n;j++)SWAP(a[l][j],a[k][j]);}
    for(i=k+1;i<n;i++){
      a[i][k]=a[i][k]/a[k][k];
      for(j=k+1;j<n;j++) a[i][j]=a[i][j]-a[i][k]*a[k][j]; 
    }
  }
  return 0;
}
void lusolv(int n,double **a,double*b,double*x,int*p){
  int i,j;
  double *y=(double*)malloc(sizeof(double)*n);
  for(i=0;i<n;i++) { y[i]=b[p[i]]; 
    for(j=0;j<i;j++) y[i]-=a[i][j]*y[j]; }
  for(i=n-1;i>=0;i--){ x[i]=y[i]; 
    for(j=i+1;j<n;j++) x[i]-=a[i][j]*x[j];
    x[i]=x[i]/a[i][i]; }
  free(y);
}
